#!/bin/bash
# Relljawa
# give credit if you use any part!!
# telegram dev @reljawa
# credit : @Rem01Gaming (telegram)
# sync 
sync

# limit background system
echo 0-2 > /dev/cpuset/system-background/effective_cpus
echo 0-2 > /dev/cpuset/system-background/cpus

# cpu_ctrl
# Menentukan direktori yang akan dicek
directory=/sys/bus/cpu/devices/

# Memeriksa apakah direktori tersebut ada
if [ -d "$directory" ]; then
    # Melakukan iterasi pada semua file di dalam direktori
    for file in "$directory"/*; do
        if [ -d "$file" ]; then
            # Mengambil nomor CPU dari jalur file
            cpu=$(basename "$file")
            
            # Mengaktifkan core_ctl untuk CPU yang terdeteksi
            echo "40" > "$file/core_ctl/busy_down_thres"
            echo "60" > "$file/core_ctl/busy_up_thres"
            echo "500" > "$file/core_ctl/offline_delay_ms"
            echo "5" > "$file/core_ctl/max_cpus"
            echo "1" > "$file/core_ctl/enable"
            echo "1" > "$file/cpufreq/schedutil/rtg_boost_freq"
            echo "0" > "$file/cpufreq/schedutil/up_rate_limit_us"
            
        fi
    done
else
    echo "Direktori $directory tidak ditemukan."
fi

echo 0x40000004 > /proc/thread-self/personality
echo 1 > /proc/self/sched_init_task_load

# optimizing I/O
echo 0 > /sys/block/sda/queue/iosched/slice_idle

echo 1 > /dev/stune/schedtune.colocate
echo 1 > /dev/stune/schedtune.schedtune_boost
echo 1 > /dev/stune/rt/schedtune.schedtune_boost
echo 0 > /dev/stune/schedtune.sched_boost_no_override

echo 1 > /dev/cpuset/memory_spread_slab
echo 1 > /dev/cpuset/top-app/sched_relax_domain_level

echo 500 > /proc/sys/kernel/random/write_wakeup_threshold

echo 80 > /sys/bus/cpu/devices/cpu0/cpufreq/schedutil/hispeed_load

echo $(cat /sys/devices/system/cpu/cpu0/cpufreq/cpuinfo_max_freq) > /sys/bus/cpu/devices/cpu0/cpufreq/schedutil/rtg_boost_freq

# Mengatur shared_cpu_list untuk index0, index1, dan index2
for cpu_dir in /sys/bus/cpu/devices/cpu*; do
    echo "1 2 3 4" > "$cpu_dir/cache/index0/shared_cpu_list"
    echo "1 2 3 4" > "$cpu_dir/cache/index1/shared_cpu_list"
    echo "1 2 3 4" > "$cpu_dir/cache/index2/shared_cpu_list"
done

# Mengatur shared_cpu_map untuk index0, index1, dan index2
for cpu_dir in /sys/bus/cpu/devices/cpu*; do
    echo 0xff > "$cpu_dir/cache/index0/shared_cpu_map"
    echo 0xff > "$cpu_dir/cache/index1/shared_cpu_map"
    echo 0xff > "$cpu_dir/cache/index2/shared_cpu_map"
done
echo 300 > /sys/kernel/gpu/gpu_min_clock

# Menggunakan find untuk mencari file dengan pola yang sesuai
# Kemudian menjalankan perintah yang diberikan pada setiap file yang ditemukan

# Mengatur thread_siblings
find /sys/bus/cpu/devices -name "thread_siblings" -exec echo 0xff > {} \;

# Mengatur core_siblings
find /sys/bus/cpu/devices -name "core_siblings" -exec echo 0xff > {} \;

# Mengatur core_siblings_list
find /sys/bus/cpu/devices -name "core_siblings_list" -exec echo 0-5 > {} \;

# disable sched overide for top-app and opt
echo 0 > /dev/stune/top-app/schedtune.sched_boost_no_override
echo 1 > /dev/cpuset/top-app/memory_migrate
echo 1 > /dev/cpuset/top-app/memory_spread_page

# memory tweaker
echo 1 > /dev/memcg/memory.use_hierarchy
echo 1 > /dev/memcg/apps/memory.move_charge_at_immigrate

# better sched and kernel
echo 1 > dev/stune/rt/schedtune.colocate
echo 90 > /dev/stune/top-app/schedtune.boost

# tunning from soc
soc_info=$(cat /proc/cpuinfo | grep 'Hardware' | awk '{print $3}')

if [[ $soc_info == "Qualcomm" ]]; then
  echo "Qualcomm SoC detected."
  echo 0 > /sys/class/kgslkgsl-3d0/throttling
elif [[ $soc_info == "MediaTek" ]]; then
  echo "MediaTek SoC detected."
  echo "3" > /proc/sys/vm/drop_caches
  echo "0" > /proc/ppm/enabled
else
  echo "Unknown SoC detected."
  # unkown soc nothing will be added
fi

# Function To Execute Preload
nohup sh $MODDIR/script/preload.sh &

exit 0